# Event Buddy - iOS - Windows Azure Mobile Services #

## Demo ##

### Introduction ###

Demos are sets of step-by-step guides and associated source code to help you demonstrate key Windows Azure services and features. Each demo provides instructions and speaking points to guide you through the process of presenting the demo to others.

In this demo you will start with a disconnected application that manages events and sessions to later connect it utilizing **Windows Azure Mobile Services** to provide structured storage for events and sessions.

> **Note:** You can download the latest build of the Windows Azure Training Kit which includes the latest stable release of this demo from here: http://bit.ly/WindowsAzureTK.

### Repository Structure ###

In the **root** folder of this repository you will find the script for this demo, **Demo.md**. Before beginning with the demo, make sure you have followed all the required steps indicated in the **Setup and Configuration** section of the document.

In the **Source** folder, you will find all the material necessary for this demo. The demo script will give you instructions on how to use this content. Typically, it will contain the following subfolders:

- **Setup:** This folder contains the dependency files and the setup scripts necessary to initialize specific configurations of the demo. Its execution is required for the majority of the demos.

- **Code:** This folder contains the source code required to perform the demo (usually there is a ***begin*** folder, which contains the starting code that you will complete by following the steps of the demo, and an ***end*** folder, which is the final result you should obtain once the demo is completed).

- **Assets:** This folder contains common content that is necessary to complete the demo.

### Get Started ###

In order to run the solutions provided by this demo you will first need to configure your environment and install any necessary prerequisites such as runtimes, components, or libraries. After cloning the Demo from the repository, follow the steps in the **Setup and Configuration** section of the Demo.md document.

### Contributing to the Repository ###

If you find any issues or opportunities for improving this tutorial, fix them!  Feel free to contribute to this project by [forking](http://help.github.com/fork-a-repo/) this repository and make changes to the content.  Once you've made your changes, share them back with the community by sending a pull request. Please see [How to send pull requests](http://help.github.com/send-pull-requests/) for more information about contributing to Github projects.

### Reporting Issues ###

If you find any issues with this tutorial that you can't fix, feel free to report them in the [issues](https://github.com/WindowsAzure-Preview/EventBuddyiOS/issues) section of this repository.